#region usings

using System;
using System.ComponentModel.Composition;
using IrrKlang;
using IrrVec3D = IrrKlang.Vector3D;
using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;
using Vector3D = VVVV.Utils.VMath.Vector3D;
using VVVV.Core.Logging;

#endregion usings

namespace VVVV.Nodes
{ 
	#region PluginInfo
	[PluginInfo(Name = "Irrklang", Category = "sound", Version = "1", Help = "Basic template with one value in/out", Tags = "")]
	#endregion PluginInfo
	public class Irrklang : IPluginEvaluate
	{
		#region fields & pins
		[Input("File", DefaultString = "hello c#")]
		ISpread<string> FFile;
        [Input("Pos", DefaultValue = 0)]
		ISpread<Vector3D> FPos;
		[Input("minimal distance", DefaultValue = 1.0)]
		ISpread<double> FmDist;
	    [Input("Playback Speed", DefaultValue = 1.0)]
		ISpread<double> FPlaySpeed;
		[Input("Play Position", DefaultValue = 1.0)]
		ISpread<double> FPlayPos;
		[Input("volume", DefaultValue = 1.0)]
		ISpread<double> FVolume;
		[Input("Play")]
		ISpread<bool> FPlay;
		[Input("Pause")]
		ISpread<bool> FPause;
		[Input("Seek Pos")]
		ISpread<bool> FSeekPos;
        [Input("Loop")]
		ISpread<bool> FLoop;
		[Input("Stop All")]
		ISpread<bool> FStopAll;
		[Input("Update")]
		ISpread<bool> Fupdate;
        [Output("length")]
		ISpread<double> Flength;
		[Output("Play Pos")]
		ISpread<double> FCurrentPos;
		ISoundEngine FEngine;	
		ISound[] FSound;

		//[Import()]
		//ILogger Flogger;
		#endregion fields & pins
	 	
        public Irrklang()
        {
			//Flogger.Log(LogType.Debug, "creating sound engine");
	    	FEngine = new ISoundEngine(); 
			//Flogger.Log(LogType.Debug, "done"); 
					
        }
		    
		//called each frame by vvvv
		public void Evaluate(int SpreadMax)
		{  
		    Flength.SliceCount = SpreadMax;
            FCurrentPos.SliceCount = SpreadMax;
            
			for (int i = 0; i < SpreadMax; i++){
			
			if (FPlay[i])
			{
			 	FSound[i] = FEngine.Play3D(FFile[i],(float)FPos[i].x,(float)FPos[i].y,(float)FPos[i].z,FLoop[i]);	
				//Flogger.Log(LogType.Debug, "triggered play");
			}
			
			if (FSound != null)
			{   
				FSound[i].Position = new IrrVec3D((float)FPos[i].x,(float)FPos[i].y,(float)FPos[i].z);
				FSound[i].MinDistance = (float)FmDist[i];
				FSound[i].PlaybackSpeed = (float)FPlaySpeed[i];
				FSound[i].Volume = (float)FVolume[i];
				FSound[i].Paused = FPause[i];
				Flength[i] = ((float)FSound[i].PlayLength)/1000;
				FCurrentPos[i] = ((float)FSound[i].PlayPosition)/1000;
			}	
			
			if (FSeekPos[i])
			{
                FSound[i].PlayPosition = ((UInt32)FPlayPos[i])*1000;
             }  
           
			if (FStopAll[i])
				FEngine.StopAllSounds();
						
		}}
	}
}
